                     ----------------------------------
                     DOCUMENTATION FOR PROGRAM 'UPDATEK'
                     ----------------------------------

                        Version 1.00 - Copyright 1992
                          Solar Terrestrial Dispatch


     All of the planetary A and K index data supplied with the daily SGDB
reports are compiled using a limited number of magnetic observatories around
the world.  As a result, the planetary A and K indices are only preliminary
values and are not as accurate as they would be if they were based on data
from many other observatories.

     Fortunately, the daily SGDB reports also contain a set of planetary A
and K indices that were observed 26 and 27 days ago (corresponding to the
SGDB acronyms "27DAY-AP" and "27DAY-KP").  These values are included in the
daily SGDB reports to permit analysis of possible imminent recurrent
tendencies based on a solar rotational cycle of approximately 27-28 days.

     These planetary A and K indices that were observed 26 and 27 days ago
are corrected values that are based on a larger set of data from other
magnetic observatories around the world.  They can therefore be used to
correct the preliminary planetary A and K indices in your BCAST-maintained
database file.

     In other words, UPDATEK simply updates the planetary A and K indices
contained in your database file to more accurate values using the corrected
planetary A and K indices that were observed 26 and 27 days ago.

     To invoke UPDATEK, simply type:

                updatek

on your DOS command line.  There are no command-line parameters or options
required to execute this program.

     Upon execution, UPDATEK runs through the entire database and searches
for inaccurate planetary A and K-indices.  When it finds inaccurate values,
UPDATEK shows you the dates of these inaccurate records and modifies them
accordingly.  A continually updated percentage value is also reported so you
can monitor the progress of UPDATEK.

     When you first execute UPDATEK, you will notice a large number of values
in your database file being modified (assuming your database is up-to-date).
This is normal.

     It is recommended you execute UPDATEK at least once per month in order
to maintain an accurate set of planetary indices, although you can execute
UPDATEK as frequently or infrequently as you wish.

     Note that UPDATEK only modifies values at least 27 days old.  It will
not modify values from recently issued SGDB reports that are less than 27
days old, since it uses the 27DAY-AP and 27DAY-KP values from the SGDB
reports.

     UPDATEK does not touch the Boulder A or K indices.  These values are
usually accurate and should not need to be modified.

